# Linux Kernel Module Cheat

###### 24.17.1.3.2. gem5 util/o3-pipeview.py O3 pipeline viewer

Mentioned at: http://www.m5sim.org/Visualization

    ./run \
      --arch aarch64 \
      --emulator gem5 \
      --userland userland/arch/aarch64/freestanding/linux/hello.S \
      --trace O3PipeView \
      --trace-stdout \
      -- \
      --cpu-type DerivO3CPU \
      --caches \
    ;
    "$(./getvar gem5_source_dir)/util/o3-pipeview.py" -c 500 -o o3pipeview.tmp.log --color "$(./getvar --arch aarch64 trace_txt_file)"
    less -R o3pipeview.tmp.log

Or without color:

    "$(./getvar gem5_source_dir)/util/o3-pipeview.py" -c 500 -o o3pipeview.tmp.log "$(./getvar --arch aarch64 trace_txt_file)"
    less o3pipeview.tmp.log

A sample output for this can be seen at: [hazardless-o3-pipeline].